{--------------------------------------------------------}
{                                                        }
{    Programa leitor de notcias e RSS                   }
{                                                        }
{    Processamento de opes                             }
{                                                        }
{    Autor: Jos Antonio Borges e Fabiano Ferreira       }
{                                                        }
{    Em maio/2013                                        }
{                                                        }
{--------------------------------------------------------}

unit neproces;
interface
uses
    windows,
    dvcrt,
    dvwin,
    dvForm,
    dvSapi,
    dvSapGlb,
    sysUtils,
    nenavega,
    nemsg,
    nevars;

procedure processa;

implementation

{--------------------------------------------------------}
{             ajuda
{--------------------------------------------------------}

procedure ajudaOpcao;
begin
    writeln;
    mensagem ('NEOPCAO',  1);  {'As opes so:'}
    mensagem ('NEAJCN01', 1);  {'N - navegar'}
    mensagem ('NEAJCN02', 1);  {'E - editar uma categoria'}
    mensagem ('NEAJCN03', 1);  {'I - incluir item em uma categoria'}
    mensagem ('NEAJCN04', 1);  {'R - remover item de uma categoria'}
    mensagem ('NEAJCN05', 1);  {'C - criar nova categoria'}
    mensagem ('NEAJCN06', 1);  {'A - atualizar a base de notcias via arquivo'}
    mensagem ('NEAJCN99', 1);  {'ESC - terminar'}

    while keypressed do readkey;
    sintBip;
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;

    procedure MenuAdiciona (msg: string);
    begin
         popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

var n: integer;
const
    tabLetrasOpcao: string [7] = 'NEIRCA' + ESC;

begin
    garanteEspacoTela (7);
    popupMenuCria (wherex, wherey, 50, length(tabLetrasOpcao), MAGENTA);
    MenuAdiciona ('NEAJCN01');  {'N - navegar'}
    MenuAdiciona ('NEAJCN02');  {'E - editar uma categoria'}
    MenuAdiciona ('NEAJCN03');  {'I - incluir item em uma categoria'}
    MenuAdiciona ('NEAJCN04');  {'R - remover item de uma categoria'}
    MenuAdiciona ('NEAJCN05');  {'C - criar nova categoria'}
    MenuAdiciona ('NEAJCN06');  {'A - atualizar a base de notcias via arquivo'}
    MenuAdiciona ('NEAJCN99');  {'ESC - terminar'}
    n := popupMenuSeleciona;
    if n > 0 then
        begin
            selSetasOpcao := tabLetrasOpcao[n];
            writeln (tabLetrasOpcao[n]);
        end
    else
        selSetasOpcao := ESC;
end;

{--------------------------------------------------------}
{                escolhe uma categoria
{--------------------------------------------------------}

function escolheCategoria (configurar: boolean): string;
var
    categorias: array [0..1000] of char;
    p: pchar;
    n, i, ncateg: integer;
begin
    escolheCategoria := '';

    if configurar then
        mensagem ('NESELSEC', 1)  {'Selecione com as setas a categoria a configurar'}
    else
        mensagem ('NESELNAV', 1);  {'Selecione com as setas a categoria a navegar'}

    getprivateProfileString (NIL, NIL, '', categorias, 1000, pchar(arqIndice));
    p := categorias;
    ncateg := 0;
    while p^ <> #$0 do
        begin
            ncateg := ncateg + 1;
            p := p + strlen(p) + 1;
        end;

    p := categorias;
    popupMenuCria (1, wherey, 50, ncateg, MAGENTA);
    while p^ <> #$0 do
        begin
            popupMenuAdiciona ('', strPas(p));
            p := p + strlen(p) + 1;
        end;

    popupMenuOrdena;
    n := popupMenuSeleciona;
    if n <= 0 then exit;

    p := categorias;
    for i := 2 to n do
        p := p + strlen(p) + 1;
    gotoxy (1, wherey-1);
    write (strPas(p), ' - ');
    clreol;

    escolheCategoria := strPas(p);
end;

{--------------------------------------------------------}
{                edita uma categoria
{--------------------------------------------------------}

procedure editaCategoria (nomeCategoria: string);
var
    itens: array [0..8000] of char;
    contItem: array [1..200] of pShortString;
    p: pchar;
    i, nitens: integer;
    umItem: array [0..255] of char;
    salva: integer;

begin
    mensagem ('NEEDICNF', 1);  {'Editore as configuraes, ao final tecle ESC'}

    salva := tamRotulosForm;
    tamRotulosForm := 3;
    p := itens;
    getprivateProfileString (pchar(nomeCategoria), NIL, '', itens, 8000, pchar(arqIndice));
    while p^ <> #$0 do
        begin
            if integer(strlen(p)) > tamRotulosForm then
                tamRotulosForm := strLen (p);
            p := p + strlen(p) + 1;
        end;
    tamRotulosForm := tamRotulosForm + 1;

    p := itens;
    nitens := 0;

    formCria;
    while p^ <> #$0 do
        begin
            nitens := nitens + 1;
            getprivateProfileString (pchar(nomeCategoria), p, '', umItem, 255, pchar(arqIndice));
            getmem (contItem[nitens], sizeof (shortString));
            contItem[nitens]^ := strPas (umItem);

            formCampo  ('', strPas (p), contItem[nItens]^, 255);
            p := p + strlen(p) + 1;
        end;
    formEdita (true);
    limpaBaixo (3);

    p := itens;
    for i := 1 to nitens do
        begin
            strPCopy (umItem, contItem[i]^);
            writePrivateProfileString (pchar(nomeCategoria), p, umItem, pchar(arqIndice));
            freeMem (contItem[i], 255);
            p := p + strlen(p) + 1;
        end;

    tamRotulosForm := salva;
    writeln;
end;

{--------------------------------------------------------}
{                inclui um item
{--------------------------------------------------------}

procedure incluiItem (nomeCategoria: string);
var item, conteudo: string;
    pitem, pconteudo: array [0..255] of char;

begin
    repeat
        mensagem ('NEITEMIN', 1);   {'Nome do item a incluir'}
        sintReadln (item);
        if item = '' then exit;

        mensagem ('NEITEMCT', 1);   {'Informe o contedo deste item'}
        sintReadln (conteudo);

        strPCopy (pitem, item);
        strPCopy (pconteudo, conteudo);
        writePrivateProfileString (pchar(nomeCategoria), pitem, pconteudo, pchar(arqIndice));
        mensagem ('NEOK', 2);        {'Ok'}
    until false;
end;

{--------------------------------------------------------}
{                cria uma nova categoria
{--------------------------------------------------------}

procedure removeItem (nomeCategoria: string);
var
    itens: array [0..8000] of char;
    p: pchar;
    i, nitens: integer;
    c, c2: char;
    n: integer;

begin
    repeat
        mensagem ('NEITEMRM', 1);      {'Escolha com as setas o item a remover'}

        p := itens;
        getPrivateProfileString (pchar(nomeCategoria), NIL, '', itens, 8000, pchar(arqIndice));
        nitens := 0;
        while p^ <> #$0 do
            begin
                nitens := nitens + 1;
                p := p + strlen(p) + 1;
            end;

        p := itens;
        popupMenuCria (1, wherey, 80, nitens, MAGENTA);
        while p^ <> #$0 do
            begin
                popupMenuAdiciona ('', strPas(p));
                p := p + strlen(p) + 1;
            end;

        n := popupMenuSeleciona;
        if n <= 0 then exit;

        p := itens;
        for i := 2 to n do
            p := p + strlen(p) + 1;

        mensagem ('NECNFRMI', 0);    {'Confirma remoo do item '}
        sintWrite (strPas (p));
        write ('? ');
        sintLeTecla (c, c2);
        writeln;
        if upcase(c) = 'S' then
            begin
                writePrivateProfileString (pchar(nomeCategoria), p, NIL, pchar(arqIndice));
                mensagem ('NEOKRM', 2);        {'Ok, removido'}
            end;

    until false;
end;

{--------------------------------------------------------}
{                cria uma nova categoria
{--------------------------------------------------------}

procedure criaNovaCategoria;
var novaCategoria: string;
begin
    mensagem ('NENOVSEC', 1);      {'Informe o nome da nova categoria:'}
    sintReadln (novaCategoria);
    if novaCategoria = '' then exit;

    writePrivateProfileString (pchar(novaCategoria), NIL, NIL, pchar(arqIndice));

    mensagem ('NEOK', 2);        {'Ok'}
end;

{--------------------------------------------------------}
{      atualiza INI a partir de um arquivo
{--------------------------------------------------------}

procedure atualizarIni;
var
    c, c2: char;
    realtera: boolean;
    categoria, item, valor, s: string;
    arq: text;
    nomeArq: string;
    p: integer;

    function existeChave (categoria, item: string): boolean;
    begin
        existeChave := sintAmbiente (categoria, item) <> '';
    end;

begin
     mensagem ('NEARQMUD', 1);  {'Informe o nome do arquivo que contm as mudanas'}
     sintReadln (nomeArq);
     if nomeArq = '' then exit;

     assign (arq, nomeArq);
     {$I-} reset (arq);  {$I+}
     if ioresult <> 0 then
         begin
             mensagem ('NEARQNEX', 2);  {'Arquivo no existe'}
             exit;
         end;

     mensagem ('NEMODIFA', 0);  {'Deseja modificar itens anteriormente criados?'}
     sintLeTecla (c, c2);
     writeln;
     if c = ESC then exit;
     realtera := upcase (c) = 'S';

     categoria := '';
     while not eof (arq) do
         begin
             readln (arq, s);
             if (s <> '') and (s[1] <> ';') and (s[1] <> '*') then
                 begin
                     if s[1] = '[' then
                          begin
                              delete (s, 1, 1);
                              delete (s, length(s), 1);
                              categoria := s;
                          end
                     else
                          begin
                              p := pos ('=', s);
                              if p > 1 then
                                  begin
                                      item := copy (s, 1, p-1);
                                      valor := copy (s, p+1, length(s));
                                      if realtera or (not existeChave (categoria, item)) then
                                          writePrivateProfileString (pchar (categoria),
                                               pchar(item), pchar(valor), pchar(arqIndice));
                                  end
                              else
                                  begin
                                      mensagem ('NECHINVA', 1); {'Chave invlida'}
                                      sintWriteln (s);
                                  end;
                          end;
                 end;
         end;

     close (arq);
     mensagem ('NEOK', 2);        {'Ok'}
end;

{--------------------------------------------------------}
{                loop de processamento                   }
{--------------------------------------------------------}

procedure processa;
var c, c2: char;
    nomeCategoria: string;
    opcao: string;
label fim;

begin
    while true do
        begin
            writeln;
            textBackground (RED);
            mensagem ('NEOQUE', 0);      {'Qual sua opo? '}
            textBackground (BLACK);
            sintLeTecla (c, c2);
            opcao := '';

            if (c = #0) and ((c2 = CIMA) or (c2 = BAIX) or (c2 = F9)) then
                  begin
                      c := selSetasOpcao;
                      if c <> #$1b then
                          opcao := copy (
                             opcoesItemSelecionado, pos ('-', opcoesItemSelecionado)-1, 999);
                  end;

            if c = #$1b then
                begin
                    writeln;
                    goto fim;
                end;

            if (c = #0) and (c2 = F1) then
                 ajudaOpcao
            else
                 begin
                     clrscr;
                     textBackground (BLUE);
                     writeln ('VoxNews' + opcao);
                     textBackground (BLACK);
                     writeln;

                     if upcase (c) in ['N', 'E', 'I', 'R'] then
                         begin
                             nomeCategoria := escolheCategoria (upcase(c) <> 'N');
                             if nomeCategoria = '' then continue;
                         end;

                     case upcase(c) of
                         'N': navegaNosSitesRss (nomeCategoria);
                         'E': editaCategoria (nomeCategoria);
                         'I': incluiItem (nomeCategoria);
                         'R': removeItem (nomeCategoria);
                         'C': criaNovaCategoria;
                         'A': atualizarIni;
                     else
                         mensagem ('NEOPINV', 1); {'Opo invlida'}
                     end;
                 end;
        end;
fim:
    writeln;
end;

end.

